libstdc++: __gnu_debug::_Safe_unordered_container_base Class Reference

libstdc++

__gnu_debug::_Safe_unordered_container_base Class Reference

`#include <safe_unordered_base.h>`

Inheritance diagram for __gnu_debug::_Safe_unordered_container_base:
[legend]

## Public Attributes
_Safe_iterator_base * | _M_const_iterators
_Safe_iterator_base * | _M_const_local_iterators
_Safe_iterator_base * | _M_iterators
_Safe_iterator_base * | _M_local_iterators
unsigned int | _M_version

## Protected Member Functions
| _Safe_unordered_container_base (_Safe_unordered_container_base &&__x) noexcept
| _Safe_unordered_container_base (const _Safe_unordered_container_base &) noexcept
| ~_Safe_unordered_container_base () noexcept
void | _M_detach_all () const
void | _M_detach_singular () const
__gnu_cxx::__mutex & | _M_get_mutex () const noexcept
constexpr void | _M_invalidate_all () const
void | _M_revalidate_singular () const
void | _M_swap (const _Safe_sequence_base &__x) const noexcept
void | _M_swap (const _Safe_unordered_container_base &__x) const noexcept
_Safe_unordered_container_base & | operator= (_Safe_unordered_container_base &&)=default
_Safe_unordered_container_base & | operator= (_Safe_unordered_container_base const &)=default

## Friends
class | _Safe_local_iterator_base

## Detailed Description

Base class that supports tracking of local iterators that reference an unordered container.

The _Safe_unordered_container_base class provides basic support for tracking iterators into an unordered container. Containers that track iterators must derived from _Safe_unordered_container_base publicly, so that safe iterators (which inherit _Safe_iterator_base) can attach to them. This class contains four linked lists of iterators, one for constant iterators, one for mutable iterators, one for constant local iterators, one for mutable local iterators and a version number that allows very fast invalidation of all iterators that reference the container.

This class must ensure that no operation on it may throw an exception, otherwise safe containers may fail to provide the exception-safety guarantees required by the C++ standard.

Definition at line 136 of file safe_unordered_base.h.

## Constructor & Destructor Documentation

## ◆ _Safe_unordered_container_base() [1/3]

__gnu_debug::_Safe_unordered_container_base::_Safe_unordered_container_base | ( |  | ) |
| inlineprotectednoexcept

Definition at line 150 of file safe_unordered_base.h.

## ◆ _Safe_unordered_container_base() [2/3]

__gnu_debug::_Safe_unordered_container_base::_Safe_unordered_container_base | ( | const _Safe_unordered_container_base & |  | ) |
| inlineprotectednoexcept

Definition at line 155 of file safe_unordered_base.h.

## ◆ _Safe_unordered_container_base() [3/3]

__gnu_debug::_Safe_unordered_container_base::_Safe_unordered_container_base | ( | _Safe_unordered_container_base && | __x | ) |
| inlineprotectednoexcept

Definition at line 160 of file safe_unordered_base.h.

## ◆ ~_Safe_unordered_container_base()

__gnu_debug::_Safe_unordered_container_base::~_Safe_unordered_container_base | ( |  | ) |
| inlineprotectednoexcept

Notify all iterators that reference this container that the container is being destroyed.

Definition at line 173 of file safe_unordered_base.h.

References _M_detach_all().

## Member Function Documentation

## ◆ _M_detach_all()

void __gnu_debug::_Safe_unordered_container_base::_M_detach_all | ( |  | ) | const
| protected

Detach all iterators, leaving them singular.

Referenced by ~_Safe_unordered_container_base().

## ◆ _M_detach_singular()

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | const
| protectedinherited

Detach all singular iterators.

Postcondition
  for all iterators i attached to this sequence, i->_M_version == _M_version.

## ◆ _M_get_mutex()

__gnu_cxx::__mutex & __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | const
| protectednoexceptinherited

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## ◆ _M_invalidate_all()

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const
| inlineconstexprprotectedinherited

Invalidates all iterators.

Definition at line 314 of file safe_base.h.

References _M_invalidate_all(), and _M_version.

Referenced by _M_invalidate_all().

## ◆ _M_revalidate_singular()

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | const
| protectedinherited

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

## ◆ _M_swap() [1/2]

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | const _Safe_sequence_base & | __x | ) | const
| protectednoexceptinherited

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

## ◆ _M_swap() [2/2]

void __gnu_debug::_Safe_unordered_container_base::_M_swap | ( | const _Safe_unordered_container_base & | __x | ) | const
| protectednoexcept

Swap this container with the given container. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

## Friends And Related Symbol Documentation

## ◆ _Safe_local_iterator_base

friend class _Safe_local_iterator_base
| friend

Definition at line 138 of file safe_unordered_base.h.

## Member Data Documentation

## ◆ _M_const_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators
| mutableinherited

The list of constant iterators that reference this container.

Definition at line 227 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## ◆ _M_const_local_iterators

_Safe_iterator_base* __gnu_debug::_Safe_unordered_container_base::_M_const_local_iterators
| mutable

The list of constant local iterators that reference this container.

Definition at line 146 of file safe_unordered_base.h.

## ◆ _M_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators
| mutableinherited

The list of mutable iterators that reference this container.

Definition at line 224 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## ◆ _M_local_iterators

_Safe_iterator_base* __gnu_debug::_Safe_unordered_container_base::_M_local_iterators
| mutable

The list of mutable local iterators that reference this container.

Definition at line 143 of file safe_unordered_base.h.

## ◆ _M_version

unsigned int __gnu_debug::_Safe_sequence_base::_M_version
| mutableinherited

The container version number. This number may never be 0.

Definition at line 230 of file safe_base.h.

Referenced by _M_invalidate_all(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

The documentation for this class was generated from the following file:

- safe_unordered_base.h